#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}

unless ($data{email}=~/.+\@.+/)
{
	push (@errors,"Your <b>e-mail</b> is incorrect. Please check and resubmit your request.<br>\n");
	&error(@errors);
}
$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT username,password,name,rname FROM rw_users,rw_rings WHERE (email='$data{email}' AND rw_users.uid=rw_rings.uid)");
while(($username,$password,$name,$rname)=$sth->fetchrow)
{
	$recname=$name;
	push (@body,"Webring: $rname\nLogin: $username\nPassword: $password\n----------------\n\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ, rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT username,password,name,rname,sname FROM rw_users,rw_rings,rw_sites WHERE (email='$data{email}' AND (rw_users.uid=rw_sites.uid AND rw_sites.rid=rw_rings.rid))");
while(($username,$password,$name,$rname,$sname)=$sth->fetchrow)
{
	$recname=$name;
	push (@body,"Webring: $rname\nWebsite: $sname\nLogin: $username\nPassword: $password\n----------------\n\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (@body)
{
$body=join("",@body);
open (MAIL,"|$mailprog");
print MAIL "To: $data{email} ($recname)\n";
print MAIL "From: $rwemail ($title)\n";
print MAIL "Subject: Your forgotten password\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT lost_pass,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
&closedb;
open(F,"<$rwpath/template/success.tpl");
@html=<F>;
close(F);
$successmsg="Your password is emailed to you. Check out your e-mail box.";
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
push (@errors,"Your <b>e-mail</b> is not exist in the database. Please check and resubmit your request.<br>\n");
&error(@errors);

sub error
{
	@error=@_;
	&closedb;
	open(F,"<$rwpath/template/error.tpl");
	@html=<F>;
	close(F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
        exit;
}
sub closedb
{
$sth="";
$dbh="";
}
